<?php
/**
 * joomla_lms.conference.php
 * (c) JoomaLMS eLearning Software http://www.joomlalms.com/
 **/

// no direct access
defined( '_JLMS_EXEC' ) or die( 'Restricted access' );
if(!defined('_NOT_AUTH')) define('_NOT_AUTH', 'You are not authorized to do this action');

$course_id = intval( mosGetParam( $_REQUEST, 'id', 0 ) );
$course_id = intval( mosGetParam( $_REQUEST, 'course_id', $course_id ));
$task 	= mosGetParam( $_REQUEST, 'task', '' );
$mode 	= mosGetParam( $_REQUEST, 'mode', '' );
$option = mosGetParam( $_REQUEST, 'option', '' );

include_once _JOOMLMS_FRONT_HOME .   DS . 'includes'.  DS . 'classes'.  DS . 'conference'.  DS . 'functions.php';
include_once _JOOMLMS_FRONT_HOME .  DS . 'includes'.  DS . 'classes'.  DS . 'conference'.  DS . 'lms.dispatcher.exception.decorator.php';
include_once _JOOMLMS_FRONT_HOME . DS . "includes" . DS . "classes" . DS . "lms.cache.helper.php";

$hideHeadingModes = array(
	'conference_room',
	'upload_popup',
	'conference_playback',
	'params',
	'save_period',
	'display_file'
);

if (!in_array($mode, $hideHeadingModes)){
	global $JLMS_CONFIG;
	$course_id = $JLMS_CONFIG->get('course_id',0);
	$pathway = array();
	$pathway[] = array('name' => _JLMS_PATHWAY_HOME, 'link' => sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid"), 'is_home' => true);
	$pathway[] = array('name' => $JLMS_CONFIG->get('course_name'), 'link' => sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid&amp;task=details_course&amp;id=$course_id"), 'is_course' => true);
	$pathway[] = array('name' => _JLMS_TOOLBAR_CONF, 'link' => sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid&amp;task=conference&amp;id=$course_id"));
	JLMSAppendPathWay($pathway);
	JLMS_ShowHeading();
}

$functionName = 'JLMS_show_' . $task;
$functionName($course_id, $option, $mode);

function JLMS_show_conference( $course_id, $option, $mode) {
	global $my, $JLMS_DB, $JLMS_CONFIG, $Itemid, $JLMS_SESSION;

	$cid = josGetArrayInts('cid', $_REQUEST);
	if (!is_array( $cid )) { $cid = array(0); }

	$JLMS_ACL = JLMSFactory::getACL();
	$isManager = $JLMS_ACL->CheckPermissions('conference', 'manage');

	require_once(_JOOMLMS_FRONT_HOME . "/includes/classes/lms.dicontainer.php");
	global $JLMS_SESSION;

	$course_params = $JLMS_CONFIG->get('course_params');
	$params_cb = new JLMSParameters($course_params);
	$enableBooking = (bool)$params_cb->get('conf_book', 0);
	$recorded_session = mosGetParam($_REQUEST, 'recorded_session', '');
	$username = mosGetParam($_REQUEST,'username','');

	$usertype = $isManager ? 1 : 2;

	//initialise dependency injection container
	$diContainer = new LMSInjectionContainer();

	jimport('joomla.registry.registry');
	$registry = JRegistry::getInstance('conference');

	$params = $_REQUEST;
	$params['isManager'] = $isManager;
	$params['enableBooking'] = $enableBooking;
	$params['courseID'] = $course_id;
	$params['ItemID'] = $Itemid;
	$params['my'] = $my;
	$params['usertype'] = $usertype;
	$registry->set('params', $params);

	/*   $registry->setValue('streamName'] = mosGetParam($_REQUEST, 'name', '');
		$registry->setValue('recordedSession'] = $recorded_session;
		$registry->setValue('username'] = $username;
		$registry->setValue('fileID'] = intval(mosGetParam ($_REQUEST, 'file_id', mosGetParam( $_REQUEST, 'id', 0 )));
		$registry->setValue('fileName'] = mosGetParam( $_REQUEST, 'filename', '' );
		$registry->setValue('agent'] = $_SERVER['HTTP_USER_AGENT'];
		$registry->setValue('enableBooking'] = $enableBooking;
		$registry->setValue(['recordedSession'] = $recorded_session;
		$registry->setValue('usertype'] = $usertype;

		$registry->setValue('ItemID'] = $Itemid;
		$registry->setValue('courseID'] = $course_id;
		$registry->setValue('option'] = $option;
		$registry->setValue('my'] = $my;
		$registry->setValue('cID'] = $cid;
		$registry->setValue('isManager'] = $isManager;
		$registry->setValue('mode'] = $mode;
		$registry->setValue('registry'] = $registry;*/

	$diContainer['db'] = $JLMS_DB;
	$diContainer['config'] = $JLMS_CONFIG;
	$diContainer['session'] = $JLMS_SESSION;
	$diContainer['registry'] = $registry;

	$options = array(
		'cachebase' => $JLMS_CONFIG->get('tmp_path')
	);
	$diContainer->setContext('cacheDriver', $options);

	jimport('joomla.cache.storage.file');
	$diContainer['cacheDriver'] = create_function('$options', 'return new JCacheStorageFile($options);');


	JLMSTriggerConferencePlugin($mode, $diContainer, $cid, $course_id, $Itemid, $option, $JLMS_SESSION, $JLMS_CONFIG);

}

function JLMSTriggerConferencePlugin($mode, $diContainer, $cid, $course_id, $Itemid, $option, $session, $config)
{
	$params = $diContainer['registry']->get('params');
	if(isset($params['file_id']) && $params['file_id'] == -2){
		JLMSRedirect($params['file_name']);
	}

	$dispatcher = new DispatcherExceptionDecorator(JDispatcher::getInstance());

	$modesThatNeedManagerRules = array(
		'edit_record',
		'change_record',
		'save_record',
		'record_delete',
		'archive',
		'booking',
		'user_access',
		'save_users',
		'delete_users_from_conference',
		'new_period',
		'period_delete',
		'edit_period',
		'save_period',

	);


	if((in_array($mode, $modesThatNeedManagerRules) && !$params['isManager'])){
		$session->set('msg',_NOT_AUTH);
		JLMSRedirect( sefRelToAbs("index.php?option=".$option."&Itemid=".$Itemid."&task=conference&mode=start_page&id=".$course_id) );
	}

	// TODO: refactoring: replace switch with inserting $mode into event name
	switch ($mode){
		case 'conference_room':

			$results = $dispatcher->trigger( 'onConferenceEnterRoom', array($diContainer));
			if(!JLMSShowPluginResult($results)){
				JLMSRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=conference&mode=archive&id=$course_id") );
			}
			break;

		case 'edit_record':
			$results = $dispatcher->trigger( 'onConferenceEditRecord', array($diContainer));
			if(!JLMSShowPluginResult($results)){
			}
			break;

		case 'change_record':
			if($params['recordID'] == 0){
				echo "<script> alert('Select an item to process'); window.history.go(-1);</script>\n";
				exit();
			}

			$results = $dispatcher->trigger( 'onConferenceChangeRecord', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'save_record':
			$results = $dispatcher->trigger( 'onConferenceSaveRecord', array($diContainer));
			if(JLMSShowPluginResult($results)){
			}

			break;

		case 'record_delete':
			$results = $dispatcher->trigger( 'onConferenceDeleteRecord', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'archive':
			$limit = intval( mosGetParam( $_REQUEST, 'limit', $session->get('list_limit', $config->get('list_limit')) ) );
			$session->set('list_limit', $limit);
			$limitStart = intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );

			$params['limit'] = $limit;
			$params['limitStart'] = $limitStart;

			$diContainer['registry']->set('params', $params);

			$results = $dispatcher->trigger( 'onConferenceShowArchive', array($diContainer));
			if(!JLMSShowPluginResult($results)){
			}

			break;

		case 'start_record':

			$results = $dispatcher->trigger( 'onConferenceStartRecord', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'booking':
			$limit = intval( mosGetParam( $_REQUEST, 'limit', $session->get('list_limit',$config->get('list_limit')) ) );
			$session->set('list_limit', $limit);
			$limitStart = intval( mosGetParam( $_REQUEST, 'limitstart', $session->get('limitstart_confbook',-99) ) );

			$do_requery = false;
			if ($limitStart == -99) {
				$limitStart = 0;
				$do_requery = true;
			}

			$session->set('limitstart_confbook', $limitStart);

			$filterStudent	= intval( mosGetParam( $_REQUEST, 'filter_stu', $session->get('filter_stu',0) ) );
			$filterTeacher = intval( mosGetParam( $_REQUEST, 'filter_teacher', $session->get('filter_teacher',$params['my']->id) ) );
			$session->set('filter_stu', $filterStudent);
			$session->set('filter_teacher', $filterTeacher);

			$params['limit'] = $limit;
			$params['limitStart'] = $limitStart;
			$params['filterStudent'] = $filterStudent;
			$params['filterTeacher'] = $filterTeacher;
			$params['doRequery'] = $do_requery;

			$diContainer['registry']->set('params', $params);

			$results = $dispatcher->trigger( 'onConferenceShowBooking', array($diContainer));
			if(!JLMSShowPluginResult($results)){
			}

			break;

		case 'user_access':
			$results = $dispatcher->trigger( 'onConferenceUserAccess', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'save_users':
			$results = $dispatcher->trigger( 'onConferenceSaveUserAccess', array($diContainer));
			JLMSShowPluginResult($results);
			break;

		case 'delete_users_from_conference':

			$results = $dispatcher->trigger( 'onConferenceDeleteUser', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'new_period':
			$results = $dispatcher->trigger( 'onConferenceNewBooking', array($diContainer));
			if(!JLMSShowPluginResult($results)){

			}
			break;

		case 'edit_period':
			$results = $dispatcher->trigger( 'onConferenceEditBooking', array($diContainer));
			if(!JLMSShowPluginResult($results)){

			}
			break;

		case 'period_delete':
			$results = $dispatcher->trigger( 'onConferenceDeleteBooking', array($diContainer));
			JLMSShowPluginResult($results);

			break;

		case 'save_period':

			$diContainer['registry']->set('params', $params);


			if (!defined('_JLMS_CONF_BOOK_EXISTS')) {
				define('_JLMS_CONF_BOOK_EXISTS','Conference with the same time period is already exists');
			}
			if($params['bookedConferenceID'] == 0){

				$params['weekDay'] = mosGetParam($_POST,'weekday');
				$params['monthDay'] = mosGetParam($_POST,'monthday');
				$diContainer['registry']->set('params', $params);
				$results = $dispatcher->trigger( 'onConferenceSaveBooking', array($diContainer));
			}else{
				$results = $dispatcher->trigger( 'onConferenceUpdateBooking', array($diContainer));
			}
			JLMSShowPluginResult($results);

			break;

		// handle all custom events
		default:
			$mode = empty($mode) ? 'start_page' : $mode;

			$eventName = $mode;
			$index = strpos($mode, '_');
			if($index !== false){
				$subStrToReplace = substr($mode, $index, 2);
				$eventName = str_replace($subStrToReplace, strtoupper($subStrToReplace[1]), $mode);
			}
			$eventName[0] = strtoupper($eventName[0]);

			$results = $dispatcher->trigger( 'onConference'.$eventName, array($diContainer));
			if(!JLMSShowPluginResult($results)){

			}
			break;
	}
}


function Daysforweeks($weeks, $month, $year)
{
	$cur_date = date("Y-m-d");
	$cur_weekday = date("w");
	$fir_day = date("w",mktime(0,0,0,$month,1,$year));
	$dates = array();
	for($i=0;$i<7;$i++)
	{
		if(in_array($i,$weeks))
		{
			for($n=0;$n<5;$n++)
			{
				$add_week = ($i<$fir_day)?($i-$fir_day+7+1):($i-$fir_day+1);
				$dataz = date("Y-m-d", mktime(0,0,0,$month,$add_week+7*$n,$year));
				//echo "-".$dataz.'<br/>';
				if(substr($dataz,5,2) == $month && $dataz>=$cur_date)
				{
					$dates[] = $dataz;
				}
			}
		}
	}
	return $dates;
}