<?php
namespace LMS\Tools\Announcements\View;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Announcements extends Base\View
{
    public function __construct($config = array())
    {
        $this->viewDir = __DIR__;
        parent::__construct($config);
        $this->acl = ServiceLocator::get('acl');
    }

    public function display($tpl = null)
    {
        $tool_path = \Juri::root().'components/com_joomla_lms/tools/announcements';
        $this->addScript( $tool_path.'/services/codebase/dhtmlxscheduler.js');
        if (!$this->acl->CheckPermissions('announce', 'manage') )
        {
        $this->addScript( $tool_path.'/services/codebase/ext/dhtmlxscheduler_readonly.js');
        }
        $this->addStyleSheet( $tool_path.'/assets/css/announcements.css');
        $this->addStyleSheet( $tool_path.'/services/codebase/dhtmlxscheduler.css');

        $model = $this->getModel();
        $this->items = $model->getItems();
        $this->featured_items = $model->getFeaturedItems();
        $this->toolbar = $this->getToolbar();

        $this->all_items_count = $model->getItemsCount();
        $this->upcoming_items_count = $model->getItemsCount('upcoming');
        $this->started_items_count = $model->getItemsCount('started');
        $this->finished_items_count = $model->getItemsCount('finished');


        return parent::display($tpl);
    }

    private function getToolbar()
    {
        jimport('cms.html.toolbar');
        $toolbar = new \LMS\Widgets\ContentToolbar();
        if ( $this->acl->CheckPermissions('announce', 'manage') )
        {
            $toolbar->addNewButton( array('href' => 'javascript: Joomla.submitbutton(\'announcements.announcement.add\')') );
        }
        return $toolbar->render();
    }

}