<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace LMS\Tools\Conference\Repositories;

use LMS\Tools\Conference\Table;
use LMS\Libraries\Base;

class Record extends Base\Repository
{

    protected $fieldMap = array(
        'recordID' => 'id',
        'courseID' => 'course_id',
        'session_name' => 'session_name',
        'record_name' => 'record_name',
        'description' => 'description',
        'published' => 'published',
        'start_date' => 'start_date',
        'user_id' => 'user_id'
    );


	public function __construct($options)
	{
		parent::__construct($options);
		$this->table = new Table\Record();
	}



	/**
	 * Return count of conference records rom DB
	 *
	 * @param int $courseID
	 * @param string $additionalWhere
	 * @return int
	 */
	public function count($courseID, $additionalWhere = '')
	{
		$query = "SELECT count(a.published)
                    FROM `#__lms_conference_records` as a
                      LEFT JOIN `#__users` as b ON a.user_id = b.id
                    WHERE a.course_id = $courseID
                      $additionalWhere
                    ORDER BY a.start_date DESC";
		$this->db->setQuery($query);
		return $this->db->loadResult();

	}

    /**
     * Returns records limited by limit and start variables
     *
     * @param int $courseID
     * @param int $start
     * @param int $limit
     * @param string $additionalWhere
     * @return mixed
     */
    public function getAll($courseID, $start, $limit, $additionalWhere = '')
    {
        $query = "SELECT a.*, b.username
                    FROM `#__lms_conference_records` as a
                        LEFT JOIN `#__users` as b ON a.user_id = b.id
                    WHERE a.course_id = ".$courseID . $additionalWhere."
                    ORDER BY a.start_date DESC
                    LIMIT " . $start . "," . $limit;

        $this->db->setQuery($query);
        return $this->db->loadObjectList();
    }

    /**
     * Returns record of conference specified by $sessioname
     *
     * @param string $sessionName
     * @return int mixed
     */
    public function getBySessionName($sessionName)
    {
        $query = "SELECT * FROM `#__lms_conference_records` WHERE session_name = '".$sessionName."' ";
        $this->db->setQuery($query);
        return $this->db->loadResult();
    }

}