<?php
/**
 * User: nester_a
 * Date: 28.11.13
 */

namespace LMS\Tools\Conference\Service;

use LMS\Libraries\Base;

class File extends Base\Service
{

	public function __construct($options = array())
	{
		parent::__construct($options);
	}

    public function uploadForCourse($courseID, $fileName)
    {
        return JLMS_uploadFile($courseID, $fileName);
    }

    public function unlink($file)
    {
        if(!isset($file->filename) || !$file->filename){
            return false;
        }

        if (file_exists(_JOOMLMS_DOC_FOLDER.$file->filename)){
            unlink (_JOOMLMS_DOC_FOLDER.$file->filename);
        }
        return true;
    }

    public function isCorrectUploaded($file)
    {
        return isset($file->upload_type) && ( $file->upload_type == 1 ) && $file->filename && $file->file_id;
    }

    public function getIntroFile()
    {
        $file = new \stdClass();
        $file->filename = "JLMS_intro.swf";
        $file->upload_type = 0;

        return $file;
    }

    /**
     * @param $filename
     * @return bool|string
     */
    public function uploadRecordFile($filename)
    {
        if(!isset($_FILES[$filename]) || !is_uploaded_file($_FILES[$filename]['tmp_name'])){
            return false;
        }
        $destinationPath = _JOOMLMS_FRONT_HOME."/upload/". time() . '_' . $_FILES[$filename]['name'];
        return move_uploaded_file($_FILES[$filename]['tmp_name'], $destinationPath) ? $destinationPath : false;
    }


}