<?php
namespace LMS\Tools\Homework\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Homeworks extends Base\View
{
	protected $extension = 'com_joomla_lms';
	protected $viewName = 'Homeworks';

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

	public function showItemsForTeacher()
	{
		$modelHomeworks = $this->getModel('Homeworks');

		$this->items = $modelHomeworks->getItemsForTeacher();
		$this->pagination = $modelHomeworks->getPagination();
		$this->state = $modelHomeworks->getState();
		$this->toolbar = $this->getToolbar();

		$this->display();
	}

	public function showItemsForLearner()
	{
		$modelHomeworks = $this->getModel('Homeworks');

		$this->items = $modelHomeworks->getItemsForLearner();
		$this->pagination = $modelHomeworks->getPagination();
		$this->state = $modelHomeworks->getState();

		$this->display('view');
	}

	public function getToolbar()
	{
		$toolbar = new \LMS\Widgets\ContentToolbar();
		$toolbar->addNewButton( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.add\')') );
		$dropDown = $toolbar->addDropDownButton( array('title' => _JLMS_ACTIONS, 'icon' => 'wrench') );
		$dropDown->addEditItem( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.edit\')') );
		$dropDown->addDeleteItem( array('href' => 'javascript: Joomla.submitbutton(\'homework.homework.delete\')') );
		$dropDown->addSeparator();
		$dropDown->addPublishItem( array('href' => 'javascript: Joomla.submitbutton(\'homework.homeworks.publish\')') );
		$dropDown->addUnpublishItem( array('href' => 'javascript: Joomla.submitbutton(\'homework.homeworks.unpublish\')') );
		return $toolbar->render();
	}

	public function helperAddPropertiesForTooltip($text_description, $show_num_words = 100, $data_placement='top')
	{
		$property = '';
		if($text_description){
			$property = 'class="hasTooltip"';
			preg_match_all('#\S+#', $text_description, $out, PREG_PATTERN_ORDER);
			if(isset($out[0]) && is_array($out[0]) && count($out[0])){
				$all_words = $out[0];
				$num_words = count($all_words);
				if($num_words > $show_num_words){
					$text_description = implode(' ', array_slice($all_words, 0, $show_num_words));
					$text_description .= ' ..';
				}
			}
			$text_description = '<strong>'._JLMS_DESCRIPTION.':</strong> ' . $text_description;
			$property .= 'title="'.\JHtml::tooltipText($text_description).'"';
			$property .= 'data-placement="'.$data_placement.'"';
		}
		return $property;
	}
}