<?php
namespace LMS\Tools\Subscriptions\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Subscriptions\Tables;

class Subscription extends Base\Repository
{
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\Subscription($this->db);
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		if(!empty($filterOptions['course_id'])) {
			$courseId = $filterOptions['course_id'];
		}
		
		if(!empty($courseId)) {			
			$query->where($alias.'.course_ref.course_id = '.$this->db->quote($courseId));
		}

		if(!empty($filterOptions['published'])){
			$query->where($alias.'.published = '.$this->db->quote($filterOptions['published']));
		}
		
		return parent::prepareFilter($query, $filterOptions);
	}
}