<?php
namespace LMS\Tools\Subscriptions\Tables;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

use Joomla\Registry\Registry;

class Subscription extends Base\Table
{
	protected $fieldMap = array(
		'title' => 'sub_name',
		'type' => 'account_type'		
	);

	protected $alias = 'subscription';

	public function __construct($db=false)
	{
		parent::__construct('#__lms_subscriptions', 'id', $db);
	}
	
	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub
		
		$this->relations = array(
			'course_ref' => array(
				'table' => new SubscriptionsCourses,
				'type' => 'INNER',
				'condition' => '{parent.id} = {child.sub_id}',
				'capacity' => self::MANY
			)
		);
	}
}