<?php
namespace LMS\Tools\Users\Repositories;
 
defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;

class Role extends Base\Repository
{	
	public function __construct($options = array()) 
	{
		parent::__construct($options);
		$this->table = new Tables\UserTypes($this->db);
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{			
		$rolesIds = array();	
		
		if(isset($filterOptions['roles'])){			
			if(in_array('student', $filterOptions['roles'])) {
				$rolesIds[] = 2;
			}			
			if(in_array('assistant', $filterOptions['roles'])) {
				$rolesIds[] = 4;
			}			
		}
		
		if(empty($rolesIds)) {
			$query->where('id < 0');
		} else {			
			$query->where('id IN ('.implode(',', $rolesIds).')');
		}			
		
		return parent::prepareFilter($query, $filterOptions);
	}
}
